import abc
from abc import abstractmethod
from djing.core.application import Application as Application
from typing import Self

class BaseConfig(metaclass=abc.ABCMeta):
    def __init__(self) -> None: ...
    @property
    def application(self): ...
    @property
    def is_valid(self): ...
    @property
    def user_model(self): ...
    @property
    def auth(self): ...
    @property
    @abstractmethod
    def license_key(self): ...
    @property
    @abstractmethod
    def name(self): ...
    @property
    @abstractmethod
    def path(self) -> str: ...
    @property
    @abstractmethod
    def currency(self): ...
    @property
    @abstractmethod
    def brand_logo(self): ...
    @property
    @abstractmethod
    def brand_colors(self): ...
    @property
    def stripped_path(self): ...
    @property
    def request(self): ...
    @property
    def base_url(self) -> str: ...
    def set_application(self, application) -> None: ...
    def set_valid(self, valid: bool = False) -> Self: ...
    def set_user_config(self, user_config) -> Self: ...
    def validate_brand_colors(self, user_config): ...
    def update(self) -> None: ...
    def __dict__(self): ...
